var _ble ;
var SERVER_UUID_STR = '0886b765-9f76-6472-96ef-ab19c539878a';
var CHARACTER_RX_UUID_STR = "0000878b-0000-1000-8000-00805f9b34fb";
var CHARACTER_TX_UUID_STR = "0000878c-0000-1000-8000-00805f9b34fb";

var CHARACTER_RX_UUID_STR_IOS = "878B";
var CHARACTER_TX_UUID_STR_IOS = "878C";

var _beOpenDevList = []; // 扫描到的有权限开的设备
var _openDoorRecord = []; // 开门日志

var _opening = false; // 开门标志
var _rssiMax = -999;  // 比较信号强度的临时变量
var _bleworking = false; // 蓝牙工作状态（持续扫描）
var _bleconnecting = false; // 蓝牙连接状态
var _bleconnectperiUUID = ''; // 当前连接的蓝牙设备 


/**
 * [ble_start 蓝牙初始化]
 * @return {[type]} [description]
 */
function ble_start(){

    _opening = false;
    
    _ble = api.require('ble');
    _ble.initManager(function(ret) {
        //api.alert({ msg: JSON.stringify(ret) });
        console.log("_ble 初始化! : " + JSON.stringify(ret)); 

        if (ret.state == "poweredOn") {
            // _ble.scan({
            //     serviceUUIDs: [SERVER_UUID_STR]
            // },function(ret) {
            //     if (ret.status) {
            //         console.log("_ble 开始扫描..... : " + JSON.stringify(ret));

            //         ble_showPeripherals();
            //     }
            // });

            _bleworking = true;
            
            ble_scan();

        } else {
            api.alert({ msg: '请检查蓝牙功能是否已经开启！' });
            _bleworking = false;
            _beOpenDevList = [];


        }
    });
}



/**
 * 启动蓝牙并回调开门动作
 * @param  {Function} callback          [description]
 * @param  {[type]}   doOpenDoorWait    [description]
 * @param  {[type]}   doOpenDoorSuccess [description]
 * @param  {[type]}   doOpenDoorFailed  [description]
 * @param  {[type]}   sbsn              [description]
 * @return {[type]}                     [description]
 */
function ble_startandopen(callback,doOpenDoorWait,doOpenDoorSuccess,doOpenDoorFailed,sbsn){
    console.log("door-ble> ble_startandopen() : sbsn= " + sbsn);

    _opening = false;

    _ble = api.require('ble');
    _ble.initManager(function(ret) {
        //api.alert({ msg: JSON.stringify(ret) });
        console.log("_ble 初始化! : " + JSON.stringify(ret)); 

        if (ret.state == "poweredOn") {
            
            _bleworking = true;

            ble_scan();

            // 回调开门
            if(callback){
                if(sbsn){
                    callback(sbsn,doOpenDoorWait,doOpenDoorSuccess,doOpenDoorFailed);
                } else {
                    setTimeout(function(){
                        callback(doOpenDoorWait,doOpenDoorSuccess,doOpenDoorFailed);
                    },500);
                }
            }

        } else {
            api.alert({ msg: '请检查蓝牙功能是否已经开启！' });
            _bleworking = false;
            _beOpenDevList = [];
        }
    });
}


function ble_scan(){
    //console.log("_ble ble_scan! ");

    setTimeout(function repeatMe() {

        _ble.scan({
            //serviceUUIDs: [SERVER_UUID_STR]
        },function(ret) {
            if (ret.status) {
                //console.log("_ble 开始扫描..... : " + JSON.stringify(ret));
                
                ble_getPeripherals();
                
            } else {
                // 尝试重新启动蓝牙模块
                console.log("_ble 开始扫描失败！尝试重新启动蓝牙模块" );
                ble_start();
            }
        });

    },1);

}



/**
 * 收集扫描到的设备信息
 * @return {[type]} [description]
 */
function ble_getPeripherals(){
    //console.log("_ble ble_showPeripherals! ");

    var timerIdx=0;

    setTimeout(function repeatMe() {

        //console.log("ble_getPeripherals  repeatMe()");

        timerIdx++;

        if(_bleworking && !_opening){

            if(timerIdx%20>0){
                // 每10毫秒检测一次是否需要继续扫描
                setTimeout(repeatMe, 10); 
            } else {
                //扫描状态下，每 10*20 毫秒取一次设备列表

                _ble.isScanning(function(ret) {
                    //api.alert({ msg: JSON.stringify(ret) });
                    if (ret.status) {

                        _ble.getPeripheral(function(ret) {
                            //console.log('ble_getperipheral <' + timerIdx + '> :' + JSON.stringify(ret));

                            // 更新可以开门的设备清单 _beOpenDev
                            if (ret && ret.peripherals) {

                                var currDevList = []; // 扫描到的有权限开的设备
                                for (var i in ret.peripherals) {
                                    // 遍历获取的设备列表
                                    var peridata = ret.peripherals[i];
                                    //alert('peridata : ' + JSON.stringify(peridata) );
                                    
                                    // 只显示有的name的设备
                                    //if(peridata.name && (peridata.name.substr(0,3)=='RD-' || peridata.name.substr(0,3)=='AM-' || peridata.name.substr(0,3)=='NR-' || peridata.name.substr(0,3)=='BC-' || peridata.name.substr(0,3)=='XM-' )){
                                    if(peridata.name && peridata.name.length>10 && peridata.name.substr(2,1)=='-'){
                                        var devSN = peridata.name.substr(3);

                                        for(var sIdx in _sbxxList){
                                            if(_sbxxList[sIdx].sbsn == devSN){

                                                var beOpenDev = {
                                                    periUUID: peridata.uuid,
                                                    periName: peridata.name,
                                                    sbsn: _sbxxList[sIdx].sbsn,
                                                    eKey: _sbxxList[sIdx].eKey,
                                                    devType: _sbxxList[sIdx].devType
                                                }
                                                
                                                // rssi = 127 ？？？ 应该是读不到信号时的返回值
                                                if(peridata.rssi){
                                                    beOpenDev.rssi = peridata.rssi;
                                                    if(peridata.rssi == 127) {
                                                        beOpenDev.rssi = -127;
                                                    }
                                                }

                                                beOpenDev.live = 15;

                                                currDevList.push(beOpenDev);
                                            }
                                        }
                                    }

                                }

                                // 合并设备列表
                                mergeBeOpenDevList(currDevList);

                                // 更新设备列表页面中设备状态
                                updateDevState();
                            }

                        });

                        //在蓝牙运行状态下，判断是否需要继续更新设备列表
                        if(_bleworking && !_opening){

                            // 判断是非需要重新启动蓝牙扫描
                            if(_beOpenDevList.length == 0 && timerIdx > 100){

                                // 取到设备列表，重启扫描
                                console.log('ble_getperipheral > 重启蓝牙扫描 <' + timerIdx + '>' + ', api.systemType: ' + api.systemType + ', api.systemVersion: ' + api.systemVersion);

                                //android 4 需要停止扫描再开始
                                if(api.systemType=='android' && api.systemVersion.substr(0,1)=='4'){
                                     console.log('ble_getperipheral > stopScan <');
                                    _ble.stopScan();
                                }

                                //if(timerIdx >= 3){
                                //    // 如果扫描5次都没有扫描到设备，重启蓝牙设备
                                //    setTimeout(ble_start(), 100); 
                                //} else {
                                //    setTimeout(ble_scan(), 100); 
                                //}

                                setTimeout(ble_start(), 1); 


                            } else {

                                //console.log('ble_getperipheral > 判断是非需要继续更新设备列表 <' + timerIdx + '>, _bleworking: ' + _bleworking + ', _bleconnecting: ' + _bleconnecting + ', _opening: ' + _opening);

                                if(timerIdx > 120){

                                    if(api.systemType=='android' && api.systemVersion.substr(0,1)=='4'){
                                        console.log('ble_getperipheral > stopScan <');
                                        _ble.stopScan();
                                    }

                                    // 重启扫描动作
                                    setTimeout(ble_scan(), 1); 
                                    //setTimeout(repeatMe, 300); 

                                } else {

                                    // 继续更新当前扫描列表
                                    setTimeout(repeatMe, 10); 
                                }

                                // 可以取到设备列表，再次更新列表中的设备
                                //setTimeout(repeatMe, 300); 
                                //setTimeout(ble_scan(), 100); 
                            }

                        }


                    } else {

                        console.log('ble_getperipheral > 取不到scan的status,退出扫描 <' + timerIdx + '>, _bleworking: ' + _bleworking + ', _bleconnecting: ' + _bleconnecting + ', _opening: ' + _opening);
                    }


                }); //end scaning

            } // end if mod

        } else {

            console.log("ble_getPeripherals  exit repeatMe()");
        }

    },1); // end repeatMe
}


/**
 * 收集扫描到的设备信息
 * @return {[type]} [description]
 */
// function ble_showPeripherals(){
//     console.log("_ble ble_showPeripherals! ");

//     var timerIdx=0
//     setTimeout(function repeatMe() {

//         timerIdx++;
//         _ble.isScanning(function(ret) {
//             //api.alert({ msg: JSON.stringify(ret) });
//             if (ret.status) {
//                 _ble.getPeripheral(function(ret) {
//                     console.log('ble_getperipheral <' + timerIdx + '> :' + JSON.stringify(ret));

//                     // 更新可以开门的设备清单 _beOpenDev
//                     if (ret && ret.peripherals) {

//                         _rssiMax = -999;
//                         _beOpenDevList = []; // 清空开门设备清单
//                         for (var i in ret.peripherals) {
//                             // 遍历获取的设备列表
//                             var peridata = ret.peripherals[i];
//                             //alert('peridata : ' + JSON.stringify(peridata) );
                            
//                             // 只显示有的name的设备
//                             if(peridata.name && (peridata.name.substr(0,3)=='RD-' || peridata.name.substr(0,3)=='AM-' || peridata.name.substr(0,3)=='NR-')){
//                                 var devSN = peridata.name.substr(3);

//                                 for(var sIdx in _sbxxList){
//                                     if(_sbxxList[sIdx].sbsn == devSN){

//                                         var beOpenDev = {
//                                             periUUID: peridata.uuid,
//                                             periName: peridata.name,
//                                             sbsn: _sbxxList[sIdx].sbsn,
//                                             eKey: _sbxxList[sIdx].eKey,
//                                             devType: _sbxxList[sIdx].devType
//                                         }

//                                         // ios 下面读取不到rssi
//                                         // 
//                                         // if(peridata.rssi){
//                                         //     beOpenDev.rssi = peridata.rssi;
//                                         //     mergeBeOpenDevList(beOpenDev);
//                                         // } else {
//                                         //     updateRSSIandMergeBeOpenDevList(beOpenDev);
//                                         // }
                                        
//                                         if(peridata.rssi){
//                                             beOpenDev.rssi = peridata.rssi;
//                                         }
//                                         mergeBeOpenDevList(beOpenDev);
//                                     }
//                                 }
//                             }

//                         }

//                         // 更新设备列表页面中设备状态
//                         updateDevState();
//                     }

//                 });

//                 setTimeout(repeatMe, 1000); 
//             }
//         });

//     },200);
// }

/**
 * 取设备信号  ios 没有返回???
 * 
 * @param  {[type]} beOpenDev [description]
 * @return {[type]}           [description]
 */
function updateRSSIandMergeBeOpenDevList(beOpenDev){

    console.log('updateRSSIandMergeBeOpenDevList > : ' + JSON.stringify(beOpenDev));

    _ble.getPeripheralRssi({
        peripheralUUID: beOpenDev.periUUID
    }, function(ret) {
        console.log('updateRSSIandMergeBeOpenDevList < ret: ' + JSON.stringify(ret));
            
        if (ret && ret.rssi) {
            beOpenDev.rssi = ret.rssi;
        }

        mergeBeOpenDevList(beOpenDev);
    });
}


/**
 * 合并扫描到的开门设备并按信号强弱排序，信号最强的放第一个
 * 
 * @param  {[type]} beOpenDev [description]
 * @return {[type]}           [description]
 */
// function mergeBeOpenDevList(beOpenDev){

//     if(beOpenDev){
//         //console.log('mergeBeOpenDevList> devSN: ' + beOpenDev.sbsn + ', rssiMax: ' + _rssiMax + ', peridata.rssi: ' + beOpenDev.rssi);
        
//         if(beOpenDev.rssi && beOpenDev.rssi > _rssiMax){
//             _rssiMax = beOpenDev.rssi;
//             _beOpenDevList.unshift(beOpenDev);
//         } else {
//             _beOpenDevList.push(beOpenDev);
//         } 
//     }

//     //console.log("mergeBeOpenDevList>  _beOpenDevList : " + JSON.stringify(_beOpenDevList)); 
// }

function mergeBeOpenDevList(currDevList){

    if(currDevList){

        // 如果信号读出来是-127，则参考上一次的rssi信号值
        if(_beOpenDevList && _beOpenDevList.length>0){
            for(var idx=0; idx < currDevList.length; idx++){
                if(currDevList[idx].rssi && currDevList[idx].rssi == -127){
                    for(var sIdx in _beOpenDevList){
                        if(_beOpenDevList[sIdx].periUUID == currDevList[idx].periUUID){
                            if(_beOpenDevList[sIdx].rssi){
                                currDevList[idx].rssi = _beOpenDevList[sIdx].rssi
                            }
                        }
                    }
                }
            }
        }

        //console.log('mergeBeOpenDevList> devSN: ' + beOpenDev.sbsn + ', rssiMax: ' + _rssiMax + ', peridata.rssi: ' + beOpenDev.rssi);
        
        //_beOpenDevList = []; // 清空开门设备清单
        //_rssiMax = -999;
        
        // 合并上一次设备列表（兼容设备广播时间差异）
        var mergDevList = _beOpenDevList;
        for(var idx=0; idx < currDevList.length; idx++){

            var beOpenDev = currDevList[idx];
            var incurr = false;

            for(var i2=0; i2 < _beOpenDevList.length; i2++){
                if(beOpenDev.periUUID == _beOpenDevList[i2].periUUID){
                    incurr = true;
                    mergDevList.splice(i2,1,beOpenDev);
                }
            }

            if(!incurr){
                console.log("mergeBeOpenDevList newdev >  beOpenDev : " + JSON.stringify(beOpenDev));  

                mergDevList.push(beOpenDev);
            }

            //console.log("mergeBeOpenDevList margelist >  currDevList : " + JSON.stringify(currDevList));  
        }



        // mergDevList = currDevList;

        // 按照信号强弱排序
        _rssiMax = -999;
        var tempDevList = [];

        for(var idx=0; idx < mergDevList.length; idx++){
            var beOpenDev = mergDevList[idx];

            //console.log("mergeBeOpenDevList>  beOpenDev : " + JSON.stringify(beOpenDev)); 

            if(beOpenDev.rssi && beOpenDev.rssi > _rssiMax){
                _rssiMax = beOpenDev.rssi;
                tempDevList.unshift(beOpenDev);
            } else {
                tempDevList.push(beOpenDev);
            }

            //console.log("mergeBeOpenDevList sort rssi >  tempDevList : " + JSON.stringify(tempDevList));
        }

        _beOpenDevList = tempDevList;
        //_beOpenDevList = currDevList;
    } 
    //else {
    //  _beOpenDevList = [];
    //}
    
    //去除过期设备列表
    var livedevliststr = "";
    for(var idx=_beOpenDevList.length-1; idx >= 0 ; idx--){
        var beOpenDev = _beOpenDevList[idx];
        beOpenDev.live--;

        if(beOpenDev.live <=0){
             console.log("mergeBeOpenDevList live timeout >  beOpenDev : " + JSON.stringify(beOpenDev));  

            _beOpenDevList.splice(idx,1);
        }

        livedevliststr += beOpenDev.periName + " : " + beOpenDev.live + " , ";

        //console.log("mergeBeOpenDevList live >  periName : " + beOpenDev.periName + " , live : " + beOpenDev.live);

        //console.log("mergeBeOpenDevList live >  _beOpenDevList : " + JSON.stringify(_beOpenDevList));  
    }

    //console.log("mergeBeOpenDevList live >  devlist : " + livedevliststr);

    //console.log("mergeBeOpenDevList>  _beOpenDevList : " + JSON.stringify(_beOpenDevList)); 
}


/**
 * 更新设备列表页面中的设备状态
 * @return {[type]} [description]
 */
function updateDevState(){
    //console.log(api.frameName + '> updateDevState');

    var exeCmd = 'updateDevStatus(\''+  JSON.stringify(_beOpenDevList) +'\');';

    api.execScript({
        name: 'doorDev',
        frameName: 'doorDev_frm',
        script: exeCmd
    });
}

/**
 * 停止扫描
 * @return {[type]} [description]
 */
function ble_stop(){
    _bleworking = false;
    _bleconnecting = false;
    _bleconnectperiUUID = '';

    if(_ble){
        _ble.isScanning(function(ret) {
            //api.alert({ msg: JSON.stringify(ret) });
            if (ret.status) {
                _ble.stopScan();
                console.log("_ble 停止扫描! : " + JSON.stringify(ret)); 
            } else {
                console.log("_ble 本来就是停止扫描状态! : " + JSON.stringify(ret)); 
            }
        });
    }

    if(_opening){
        _opening = false;
        $api.byId('doorOpenBtn').src='../image/door_openbtn.png';
        $api.text($api.byId("doorOpenWaitTime"),'');   
    }
}



/**
 * 开门入口，开距离最近的门
 * @return {[type]} [description]
 */
function ble_openDoorByRssi(doOpenDoorWait,doOpenDoorSuccess,doOpenDoorFailed){

    if(!_bleworking){
        //api.alert({ msg: '请检查蓝牙功能是否已经开启！' });
        ble_startandopen(ble_openDoorByRssi,doOpenDoorWait,doOpenDoorSuccess,doOpenDoorFailed);
        return;
    }

    if(_opening || _bleconnecting){
        console.log('正在开门操作，忽略');
        return;
    }

    if(! _sbxxList){
        alert('无可用设备!');
        return;
    }

    if(_beOpenDevList && _beOpenDevList.length==0){
        setTimeout(function(){
            if(_beOpenDevList && _beOpenDevList.length==0){
                alert('请靠近您所要开的门再点我!');
                return;
            }

            console.log('opendoor>  _beOpenDevList: ' + JSON.stringify(_beOpenDevList));
            for(var dIdx in _beOpenDevList){
                var beOpenDev = _beOpenDevList[dIdx];
                console.log('opendoor: ' + JSON.stringify(beOpenDev));

                ble_opendoor(beOpenDev.periUUID, beOpenDev.eKey,beOpenDev.sbsn,doOpenDoorWait,doOpenDoorSuccess,doOpenDoorFailed,beOpenDev.devType,0);
                return; // 只开第一个门，信号最强的一个门
            }  

        },500);

    } else {

        console.log('opendoor>  _beOpenDevList: ' + JSON.stringify(_beOpenDevList));
        for(var dIdx in _beOpenDevList){
            var beOpenDev = _beOpenDevList[dIdx];
            console.log('opendoor: ' + JSON.stringify(beOpenDev));

            ble_opendoor(beOpenDev.periUUID, beOpenDev.eKey,beOpenDev.sbsn,doOpenDoorWait,doOpenDoorSuccess,doOpenDoorFailed,beOpenDev.devType,0);
            return; // 只开第一个门，信号最强的一个门
        }    
    }
    
}


/**
 * 开指定的门
 * @param  {[type]} sbsn [description]
 * @return {[type]}      [description]
 */
function ble_openDoorBySbsn(sbsn,doOpenDoorWait,doOpenDoorSuccess,doOpenDoorFailed){

    console.log('door-ble> ble_openDoorBySbsn() sbsn: ' + sbsn);

    if(!_bleworking){
        //api.alert({ msg: '请检查蓝牙功能是否已经开启！' });
        //ble_start();
        ble_startandopen(ble_openDoorBySbsn,sbsn,doOpenDoorWait,doOpenDoorSuccess,doOpenDoorFailed,beOpenDev.devType);
        return;
    }

    
    if(!sbsn){
        alert('请指定要开门的设备');
        return;
    }

    if(_opening || _bleconnecting){
        console.log('正在开门操作，忽略');
        return;
    } 


    if(! _beOpenDevList && _beOpenDevList.length==0){
        alert('请靠近您所要开的门再点我!');
        return;
    }

    // 判断是否找到指定的开门设备
    var getSbsn = false;

    console.log('opendoor>  _beOpenDevList: ' + JSON.stringify(_beOpenDevList));
    for(var dIdx in _beOpenDevList){
        var beOpenDev = _beOpenDevList[dIdx];
        if(beOpenDev.sbsn == sbsn){
            getSbsn=true;
            console.log('opendoor: ' + JSON.stringify(beOpenDev));
            ble_opendoor(beOpenDev.periUUID, beOpenDev.eKey,beOpenDev.sbsn,doOpenDoorWait,doOpenDoorSuccess,doOpenDoorFailed,beOpenDev.devType,0);
        }
    }

    if(!getSbsn){
        if(doOpenDoorFailed){
            doOpenDoorFailed(sbsn,'指定的开门设备不可用，请靠近您所要开的门再点我！');
        }
    }
}



/**
 * [ble_opendoor 蓝牙开门，需要传入设备UUID和eKey]
 * @param  {[type]} periUUID [description]
 * @param  {[type]} eKey     [description]
 * @param  {[type]} sbsn     [description]
 * @return {[type]}          [description]
 */
function ble_opendoor(periUUID,eKey,sbsn,doOpenDoorWait,doOpenDoorSuccess,doOpenDoorFailed,devType,reTry){

    console.log('ble_opendoor  periUUID: ' + periUUID + ', eKey: ' + eKey + ', sbsn: ' + sbsn+ ', devType: ' + devType);

    _opening=true;

    if(doOpenDoorWait && reTry==0){
        doOpenDoorWait();
    }

    console.log('ble.connect > peripheralUUID: ' + periUUID);
    // 连接设备
    _ble.connect({
        peripheralUUID: periUUID
    }, function(ret, err) {

        console.log('ble.connect < ret: ' + JSON.stringify(ret));
        //api.alert({ msg: JSON.stringify(ret) });
                    
        if (ret.status) {

            _bleconnecting = true;
            _bleconnectperiUUID = periUUID;

            // 取服务
            _ble.discoverService({
                peripheralUUID: periUUID
            }, function(ret) {
                //api.alert({ msg: JSON.stringify(ret) });
                   
                if (ret) {
                    if(ret.status){

                        for (var i in ret.services) {
                            var servUUID = ret.services[i];
                            if(servUUID.toLowerCase() == SERVER_UUID_STR.toLowerCase()){

                                _ble.discoverCharacteristics({
                                    peripheralUUID: periUUID,
                                    serviceUUID: servUUID
                                }, function(ret) {
                                    //api.alert({ msg: 'discoverCharacteristics: '+JSON.stringify(ret) });

                                    if (ret.status) {

                                        for (var c in ret.characteristics) {
                                            
                                            if(ret.characteristics[c].uuid.toLowerCase()==CHARACTER_TX_UUID_STR.toLowerCase() || ret.characteristics[c].uuid.toLowerCase()==CHARACTER_TX_UUID_STR_IOS.toLowerCase()){

                                                //api.alert({ msg: 'Characteristic: '+JSON.stringify(ret.characteristics[c]) });
                                                var servUUID = ret.characteristics[c].serviceUUID;
                                                var charUUID = ret.characteristics[c].uuid;

                                                // opendoor 
                                                // 开门第一步操作
                                                _opendoor_m1(periUUID,servUUID,charUUID,eKey,sbsn,doOpenDoorSuccess,doOpenDoorFailed,devType);
                                                
                                            }
                                        }

                                    }
                                });

                            }
                        }

                    }
                }

            });


        } else {
            //alert(err.code);
            //api.alert({ msg: 'connect :'+JSON.stringify(err) });
            console.log('connect :'+JSON.stringify(err) + ", reTry: " + reTry);

            if(reTry < 2 && err && err.code && err.code == 2){
                console.log('connect err code == 2 , retry reconnect');

                setTimeout(function(){
                    ble_opendoor(periUUID,eKey,sbsn,doOpenDoorWait,doOpenDoorSuccess,doOpenDoorFailed,devType,reTry+1);
                },900);

            } else {

                setTimeout(function(){
                    _bleconnecting = false;
                    _bleconnectperiUUID = '';
                },1);

                // 判断是否正常开门操作结束
                if(_opening){
                    if(doOpenDoorFailed){
                        doOpenDoorFailed(sbsn,'设备连接断开！');
                    }

                    setTimeout(function(){
                        _opening=false;
                    },100);
                }

                setTimeout(function(){
                    if(_bleworking){
                        console.log('bedisconnect : 继续更新设备列表。。。。');
                        //ble_scan();
                        ble_getPeripherals();
                    }
                },200);

                // 设备连接关闭，隐藏状态图标
                api.hideProgress();
            }

        }
    });


};


/**
 * 关闭当前连接
 * @return {[type]} [description]
 */
function ble_disconnect (){
    if(_bleconnecting){
        _ble.disconnect({
            peripheralUUID: _bleconnectperiUUID
        }, function(ret, err) {
            if (ret.status) {
                console.log("ble_disconnect ： 断开连接成功！" + ", _bleworking: " + _bleworking + ", _opening: " + _opening);

                // setTimeout(function(){
                //     _bleconnecting = false;
                //     _bleconnectperiUUID = '';
                // },200);

                if(_opening){
                    // if(doOpenDoorFailed){
                    //     doOpenDoorFailed(sbsn,'设备连接断开！');
                    // }

                    setTimeout(function(){
                        _opening=false;

                    },100);
                }
            }

            setTimeout(function(){
                if(_bleworking){
                    console.log('disconnect : 继续更新设备列表。。。。');
                    //ble_scan();
                    ble_getPeripherals();
                }
            },200);

            setTimeout(function(){
                _bleconnecting = false;
                _bleconnectperiUUID = '';
            },1);

        });
    }
}



/**
 * 开门操作，第一步
 * @param  {[type]} periUUID [description]
 * @param  {[type]} servUUID [description]
 * @param  {[type]} charUUID [description]
 * @param  {[type]} eKey     [description]
 * @param  {[type]} sbsn     [description]
 * @return {[type]}          [description]
 */
function _opendoor_m1(periUUID,servUUID,charUUID,eKey,sbsn,doOpenDoorSuccess,doOpenDoorFailed,devType){
    console.log('_opendoor_m1 # periUUID: ' + periUUID + ', servUUID: ' + servUUID + ', charUUID: ' + charUUID + ', sbsn: ' + sbsn + ', devType: ' + devType);

    // // 第一步数据
    // var sendDATA = _getdata_s1();
    // //alert(sendDATA);
    
    // ble_writeValueForCharacteristic(periUUID,servUUID,charUUID,sendDATA,sbsn,doOpenDoorFailed);


    // // 设置数据监听
    // if(charUUID.toUpperCase()==CHARACTER_TX_UUID_STR.toUpperCase()){
    //     ble_setNotifyForOpenDoor(periUUID,servUUID,CHARACTER_RX_UUID_STR,eKey,sbsn,doOpenDoorSuccess,doOpenDoorFailed,devType);
    // }

    // if(charUUID.toUpperCase()==CHARACTER_TX_UUID_STR_IOS.toUpperCase()){
    //     ble_setNotifyForOpenDoor(periUUID,servUUID,CHARACTER_RX_UUID_STR_IOS,eKey,sbsn,doOpenDoorSuccess,doOpenDoorFailed,devType);
    // }

    // 延时读取
    setTimeout(function(){

        // 设置数据监听
        if(charUUID.toUpperCase()==CHARACTER_TX_UUID_STR.toUpperCase()){
            ble_setNotifyForOpenDoor(periUUID,servUUID,CHARACTER_RX_UUID_STR,eKey,sbsn,doOpenDoorSuccess,doOpenDoorFailed,devType);
        }

        if(charUUID.toUpperCase()==CHARACTER_TX_UUID_STR_IOS.toUpperCase()){
            ble_setNotifyForOpenDoor(periUUID,servUUID,CHARACTER_RX_UUID_STR_IOS,eKey,sbsn,doOpenDoorSuccess,doOpenDoorFailed,devType);
        }

    },1);


    // 延时读取
    setTimeout(function(){

        // 第一步数据
        var sendDATA = _getdata_s1();
        //alert(sendDATA);
        
        ble_writeValueForCharacteristic(periUUID,servUUID,charUUID,sendDATA,sbsn,doOpenDoorFailed);


    },100);



}


/**
 * 组装开门数据第一步
 * @return {[type]} [description]
 */
function _getdata_s1(){
    console.log('_getdata_s1');
    // 第一步数据
    var attach_data = [1];
    ////var sendDATA = 'ab08663f13902422d4e9a382'.toUpperCase();
    var sendDATA = XXtea.byteToHexStr(Communication.getSendData(3, 1, attach_data));

    console.log('_getdata_s1 ret: ' + sendDATA);

    return sendDATA
}


/**
 * 组装开门数据第二步
 * @param  {[type]} sRevData [description]
 * @param  {[type]} eKey     [description]
 * @return {[type]}          [description]
 */
function _getdata_s2(sRevData, eKey, devType){
    //sRevData = "ab10bead385c68fe3d1fd177136d10498ecd2752";//alert(sRevData.length);
    console.log('_getdata_s2  sRevData:' + sRevData + ', devType:' + devType);
    
    var revData = XXtea.getKey(sRevData);
    //alert(XXtea.byteToHex(revData));
    console.log('_getdata_s2  revData:' + XXtea.byteToHex(revData));
    
    var l2_data = Communication.L1_receive_data(revData);   
    // alert("2. L2_resolve_data: " + XXtea.byteToHex(l2_data) + ". len=" + l2_data.length);    
    console.log('_getdata_s2  l2_data:' + XXtea.byteToHex(l2_data) + ". len=" + l2_data.length);

    var s_eKey = eKey;

    var temp_data = l2_data.slice(2, l2_data.length);
    //var cardno = "0000000000";    //(根据设备类型, 类型=1:从eKey提取)
    var cardno = s_eKey.substr(54, 10); //(根据设备类型, 类型=1:从eKey提取)
    console.log('_getdata_s2  cardno:' + cardno);
    
    var userIdentity = s_eKey.substring(32, 43);
    
    var b_user = "";
    
    if (devType == "1") {
    	b_user = Communication.readCardnoTobyteArray(cardno);   //alert("b_user, length=" + b_user.length + ": data=" + XXtea.byteToHex(b_user));
	}
	else if (devType == "3") {
		var cardno_long = 0;
		try {
			cardno_long = Number(cardno);
		} catch (e){
		}
		if (cardno_long == 0) {
			cardno = userIdentity;
		}
		b_user = Communication.HexString2byteArray(cardno);
	}
	else {
		b_user = Communication.phoneTobyteArray(userIdentity);
	}
	
    var s_devkey = s_eKey.substr(0, 32);    //alert("dev_key=" + s_devkey);

    console.log('_getdata_s2  temp_data: ' + XXtea.byteToHex(temp_data) + ', s_devkey: ' + XXtea.byteToHex(s_devkey) + ', b_user: ' + XXtea.byteToHex(b_user));

    var rand_data = Communication.handlerRandom(temp_data, s_devkey, b_user);       
    //alert("rand data(" + rand_data.length + ") " + XXtea.byteToHex(rand_data));
    console.log('_getdata_s2  rand data(' + rand_data.length + ") " + XXtea.byteToHex(rand_data));

    var send_data = Communication.getSendData(3, 2, rand_data);
    //alert("3.send data(" + send_data.length + ") " + XXtea.byteToHex(send_data));
    console.log('_getdata_s2  send data(' + send_data.length + ')' + XXtea.byteToHex(send_data));

    var sendDATA = XXtea.byteToHexStr(send_data);

    return sendDATA;
}

/**
 * 解码从设备收到的数据
 * @param  {[type]} sRevData [description]
 * @return {[type]}          [description]
 */
function _decodeRevData(sRevData){
    //sRevData = "ab08eeece3d7303d0d9d541d";
    console.log('_decodeRevData  sRevData:' + sRevData);

    var revData = XXtea.getKey(sRevData);

    var l2_data = Communication.L1_receive_data(revData);
    //alert("4. L2_resolve_data: " + XXtea.byteToHex(l2_data) + ". len=" + l2_data.length);
    console.log("_decodeRevData resolve_data: " + XXtea.byteToHex(l2_data) + ". len=" + l2_data.length);

    var sendDATA = XXtea.byteToHexStr(l2_data);

    return sendDATA;
}



/**
 * 组装开门数据第四步 取设备信息
 * @param  {[type]} sRevData [description]
 * @return {[type]}          [description]
 */
function _getdata_s4(sRevData, eKey, devType){
    //sRevData = "ab08eeece3d7303d0d9d541d";
    console.log('_getdata_s4  sRevData:' + sRevData + ', eKey: ' + eKey);

    var s_ekey = eKey;  // 68字符，34 bytes
    var s_devkey = s_ekey.substr(0, 32); 
    var key_from = parseInt(s_ekey.substr(64, 1));
    var manager_phone = s_ekey.substr(43, 11);  // 00000000000
    var send_phone = Communication.phoneTobyteArray(manager_phone, key_from); // 0x20,00,00,00,00 
    var dev_key = XXtea.getKey(s_devkey);
    var enc_dkey = Communication.encode(dev_key);       
    var key_check = enc_dkey.slice(enc_dkey.length - 4);     
    var data1 = key_check.concat(send_phone);

    var l4_data = Communication.getSendData(2, 20, data1);

    console.log("_getdata_s4 getSendData: " + XXtea.byteToHex(l4_data) + ". len=" + l4_data.length);

    var sendDATA = XXtea.byteToHexStr(l4_data);

    return sendDATA;
}






function ble_writeValueForCharacteristic(periUUID,servUUID,charUUID,uValue,sbsn,doOpenDoorFailed){
    var myWriteType = 'withoutResponse';
    // if(charUUID.toUpperCase()==CHARACTER_TX_UUID_STR_IOS.toUpperCase()){
    //     myWriteType = 'withoutResponse';
    // }
    console.log('ble_writeValueForCharacteristic > periUUID: ' + periUUID + ', servUUID: ' + servUUID + ', charUUID: ' + charUUID + ', uValue: ' + uValue + ', writeType: ' + myWriteType );

    _ble.writeValueForCharacteristic({
        peripheralUUID: periUUID,
        serviceUUID: servUUID,
        characteristicUUID: charUUID,
        value: uValue,
        writeType: myWriteType
    }, function(ret,err) {
        if (ret) {
            //api.alert({ msg: 'ble_writeValueForCharacteristic: ' + JSON.stringify(ret) });
            console.log('ble_writeValueForCharacteristic < ret: ' + JSON.stringify(ret));
        }

        if (err) {
            //api.alert({ msg: 'ble_writeValueForCharacteristic err: ' + JSON.stringify(err) });
            console.log('ble_writeValueForCharacteristic < err: ' + JSON.stringify(err));

            if(_opening){
                if(doOpenDoorFailed){
                    doOpenDoorFailed(sbsn,'设备繁忙，请稍后再试！');
                }

                //_opening=false;
            }

            ble_disconnect();
        }
    });
};


// _op_opendorr Notify
function ble_setNotifyForOpenDoor(periUUID,servUUID,charUUID,eKey,sbsn,doOpenDoorSuccess,doOpenDoorFailed,devType){
    console.log('ble_setNotifyForOpenDoor:  beginNotify  > periUUID: ' + periUUID + ', servUUID: ' + servUUID + ', charUUID: ' + charUUID);

    _ble.setNotify({
        peripheralUUID: periUUID,
        serviceUUID: servUUID,
        characteristicUUID: charUUID
    }, function(ret) {
        if (ret) {
            //api.alert({ msg: 'ble_setNotifyForOpenDoor: '+JSON.stringify(ret) });
            console.log('ble_setNotifyForOpenDoor: ' + JSON.stringify(ret));

            //alert(ret.characteristic.value);
            console.log('NotifyForOpenDoor value:' + ret.characteristic.value + ', length: ' + ret.characteristic.value.length);

            //  读取到的设备第二步返回的加密数据
            if(ret.characteristic.value.length == 40){

                // 第二步操作
                var s2data = _getdata_s2(ret.characteristic.value,eKey,devType);

                // 第二步数据写入设备
                // android
                if(ret.characteristic.uuid.toUpperCase()==CHARACTER_RX_UUID_STR.toUpperCase()){
                    console.log('ble_writeValueForCharacteristic(android) value:' + s2data);
                    ble_writeValueForCharacteristic(periUUID,servUUID,CHARACTER_TX_UUID_STR,s2data,sbsn,doOpenDoorFailed);
                }

                // ios
                if(ret.characteristic.uuid.toUpperCase()==CHARACTER_RX_UUID_STR_IOS.toUpperCase()){
                    console.log('ble_writeValueForCharacteristic(ios) value:' + s2data);
                    ble_writeValueForCharacteristic(periUUID,servUUID,CHARACTER_TX_UUID_STR_IOS,s2data,sbsn,doOpenDoorFailed);
                }
            }

            //  读取到的设备第三步返回的加密数据
            if(ret.characteristic.value.length == 24){

                // 第三步操作
                var s3data = _decodeRevData(ret.characteristic.value);

                console.log('s3data : '  + s3data);

                // 根据报文命令分别处理
                if(s3data && s3data.substr(0,4)=='0302'){ // 开门

                    console.log('收到开门响应报文 : '  + s3data);
                    
                    if(s3data.substr(4,2)=='00'){

                        if(devType == '4'){
                            // 如果开门成功，且设备类型为蓝牙门锁时，取设备电量信息
                            var s4data = _getdata_s4(ret.characteristic.value,eKey,devType);

                            // 第四步数据写入设备
                            // android
                            if(ret.characteristic.uuid.toUpperCase()==CHARACTER_RX_UUID_STR.toUpperCase()){
                                console.log('ble_writeValueForCharacteristic(android) value:' + s4data );
                                ble_writeValueForCharacteristic(periUUID,servUUID,CHARACTER_TX_UUID_STR,s4data,sbsn,doOpenDoorFailed);
                            }

                            // ios
                            if(ret.characteristic.uuid.toUpperCase()==CHARACTER_RX_UUID_STR_IOS.toUpperCase()){
                                console.log('ble_writeValueForCharacteristic(ios) value:' + s4data );
                                ble_writeValueForCharacteristic(periUUID,servUUID,CHARACTER_TX_UUID_STR_IOS,s4data,sbsn,doOpenDoorFailed);
                            }

                        } else {
                            // 其他设备，直接返回成功
                            if(doOpenDoorSuccess){
                                doOpenDoorSuccess(sbsn,'0');
                            }

                            //_opening=false;

                            ble_disconnect();  
                        }

                    }  else {

                        var retcode = 'ff';
                        if(s3data){
                            retcode = s3data.substr(4,2);
                        }

                        if(doOpenDoorFailed){
                            doOpenDoorFailed(sbsn,'开门失败！code:' + retcode);
                        }

                        //_opening=false;

                        ble_disconnect();  
                    }


                } else if (s3data && s3data.substr(0,4)=='0214'){

                    console.log('收到读取设备电量响应报文 : '  + s3data);

                    if(s3data.substr(4,2)=='00'){

                        var s_sbdl = s3data.substr(6,2);

                        var sbdl = parseInt(s_sbdl, 16);

                        console.log('收到读取设备电量是 : '  + sbdl.toString(10) + '%' );


                        if(doOpenDoorSuccess){
                            doOpenDoorSuccess(sbsn,sbdl.toString(10));
                        }

                        //_opening=false;

                        ble_disconnect();
                    }
                        
                } else {
                    console.log('收到未识别的返回报文！！！');
                }

            }

        }
    });
};



/**
 * [uploadOpenRecord 上传开门日志]
 * @param  {[type]} sbsn [设备序列号]
 * @param  {[type]} jlyy [记录原因]
 * @return {[type]}      [description]
 */
function uploadOpenRecord(sbsn,jlyy,sbdl){

    if(_sbxxList){
        for(var i in  _sbxxList){
            var sbxx = _sbxxList[i];
            if(sbxx.sbsn==sbsn){

                var currDate = new Date(); 

                var openRecord = {
                    sbsn: sbsn,
                    jlsyh: '0',
                    jlyy: jlyy,
                    jlsj: getDateTime14(),
                    sbdl: sbdl,
                    mh: '1',
                    jcmlx: '1',
                    mksn: sbxx.mksn,
                    sssq: sbxx.sb_sssq
                }

                // 获取当前未上传的门禁日志列表
                var openRecordList = getData('openrecordlist');
                if(openRecordList){
                    openRecordList = JSON.parse(openRecordList);
                } else {
                    openRecordList = [];
                }
                openRecordList.push(openRecord);
                putData('openrecordlist', openRecordList);


                // 将门禁日志列表上传到服务器
                uploadOpenRecordtoServer(openRecordList);


                // var bodyParam = {
                //     action: "bluetooth_record",
                //     req: {
                //         sssq: openRecord.sssq,
                //         sbsn: openRecord.sbsn,
                //         jlsyh: openRecord.jlsyh,
                //         jlyy: openRecord.jlyy,
                //         jlsj: openRecord.jlsj,
                //         sbdl: openRecord.sbdl,
                //         mh: openRecord.mh,
                //         jcmlx: openRecord.jcmlx,
                //         mksn: openRecord.mksn
                //     }
                // }

                // console.log('uploadOpenRecord> bodyParam :' + JSON.stringify(bodyParam) );

                // // Post
                // ajaxPost(bodyParam, function (ret, err) {
                //     console.log('uploadOpenRecord< ret: ' + JSON.stringify( ret) );

                //     if (ret && ret.state) {
                //         console.log('uploadOpenRecord< 门禁日志上传成功！');

                //     } else {
                //         // 上传失败

                //         if(ret && !ret.state){
                //             console.log('uploadOpenRecord state err！');
                //             // if(ret.cljg){
                //             //     api.toast({msg: ret.cljg});
                //             // }
                //         }

                //         if(err){
                //             //api.toast({msg: err.msg});
                //             console.log('uploadOpenRecord<  err: ' + JSON.stringify(err) );
                //         }

                //         // 如果上传失败，将开门记录保存到本地
                //         var openRecordList = getData('openrecordlist');
                //         if(openRecordList){
                //             openRecordList = JSON.parse(openRecordList);
                //         } else {
                //             openRecordList = [];
                //         }
                //         openRecordList.push(openRecord);
                //         putData('openrecordlist', openRecordList);

                //     }

                //     api.hideProgress();
                // });

            }
        }
    }

}


/**
 * [uploadtoServer 上传日志到服务器]
 * @param  {[type]} openRecordList [开门日志列表]
 * @return {[type]}                [description]
 */
function uploadOpenRecordtoServer(openRecordList){

    if(openRecordList && openRecordList.length>0){

        var tmpOpenRecord = openRecordList[0];

        console.log('uploadOpenRecordtoServer > tmpOpenRecord: ' + JSON.stringify( tmpOpenRecord) );

        var bodyParam = {
            action: "bluetooth_record",
            req: {
                sssq: tmpOpenRecord.sssq,
                sbsn: tmpOpenRecord.sbsn,
                jlsyh: tmpOpenRecord.jlsyh,
                jlyy: tmpOpenRecord.jlyy,
                jlsj: tmpOpenRecord.jlsj,
                sbdl: tmpOpenRecord.sbdl,
                mh: tmpOpenRecord.mh,
                jcmlx: tmpOpenRecord.jcmlx,
                mksn: tmpOpenRecord.mksn
            }
        }

        console.log('uploadOpenRecordtoServer> bodyParam :' + JSON.stringify(bodyParam) );

        // Post
        ajaxPost(bodyParam, function (ret, err) {
            console.log('uploadOpenRecordtoServer< ret: ' + JSON.stringify( ret) );

            if (ret && ret.state) {
                console.log('uploadOpenRecordtoServer< 门禁日志上传成功！');

                // 移除已经上传到记录，并保存列表
                openRecordList.splice(0,1);
                putData('openrecordlist', openRecordList);


                if(openRecordList && openRecordList.length>0){
                    // 继续上传
                    console.log('uploadOpenRecordtoServer> 继续上传开门日志');
                    uploadOpenRecordtoServer(openRecordList); 
                }

            } else {
                // 上传失败
                if(ret && !ret.state){
                    console.log('uploadOpenRecordtoServer state err！');
                    // if(ret.cljg){
                    //     api.toast({msg: ret.cljg});
                    // }
                }

                if(err){
                    //api.toast({msg: err.msg});
                    console.log('uploadOpenRecordtoServer<  err: ' + JSON.stringify(err) );
                }

                // 如果上传失败，将开门记录保存到本地
                // var tmpOpenRecordList = getData('openrecordlist');
                // if(tmpOpenRecordList){
                //     openRecordList = JSON.parse(openRecordList);
                // } else {
                //     openRecordList = [];
                // }
                // openRecordList.push(openRecord);
                // putData('openrecordlist', openRecordList);

            }

            api.hideProgress();
        });



    }


}
