/**
 * door-openui.js
 * 开门动画
 */
(function( window, undefined ) {
    "use strict";
    var doorOpenUI = function() {
    };
    var isShow = false;
    doorOpenUI.prototype = {
        init: function(params,callback){
            if(params){
                this.frameBounces = params.frameBounces;
                this.openTitle = params.openTitle;
                this.openTimeout = params.openTimeout;
                this.openBtnOpeningImg = params.openBtnOpeningImg;
                this.openBtnEndImg = params.openBtnEndImg;
                this.openBannerImg = params.openBannerImg;
            }
            this.maskDiv;
            this.doorOpenUIDiv;
            var self = this;
            self.open(params,callback);
        },
        open: function(params,callback) {
            var buttonsHtml = '';
        	var self = this;
            //if(self.doorOpenUIDiv || !self.buttons)return;
            if(!self.maskDiv){
                self.maskDiv = document.createElement("div");
                self.maskDiv.className = "aui-mask";
                document.body.appendChild(self.maskDiv);
            }
            if(!self.openTitle)self.openTitle = '正在为您开门请稍候';
            if(!self.openTimeout)self.openTimeout = 60;
            if(!self.openBtnOpeningImg)self.openBtnOpeningImg = '../image/door_openbtn_opening.gif';
            if(!self.openBtnEndImg)self.openBtnEndImg = '../image/door_openbtn.png';
            if(!self.openBannerImg)self.openBannerImg = '../image/myBackground.jpg';

            self.doorOpenUIDiv = document.createElement("div");
            self.doorOpenUIDiv.className = "aui-sharebox aui-grid";
            document.body.appendChild(self.doorOpenUIDiv);

            buttonsHtml =  '<section class="aui-content aui-margin-t-15 aui-margin-b-15" >'
            buttonsHtml += '    <div class="aui-list aui-media-list aui-list-noborder">'
            buttonsHtml += '        <div class="aui-list-item aui-padded-l-0">'
            buttonsHtml += '            <div class="aui-media-list-item-inner aui-list-item-center">'
            buttonsHtml += '                 <div class="aui-list-item-media aui-padded-0" style="width:10rem;">'
            buttonsHtml += '                     <img src="'+self.openBtnOpeningImg+'" id="doorOpenBtnUI">'
            buttonsHtml += '                 </div>'
            buttonsHtml += '             </div>'
            buttonsHtml += '             <div class="aui-list-item-inner">'
            buttonsHtml += '                 <div class="aui-list-item">'
            buttonsHtml += '                     <div class="aui-font-size-14 aui-text-center" style="color: #757575" id="doorOpenWaitTimeUI">'
            buttonsHtml += self.openTitle
            buttonsHtml += '                     </div>'
            buttonsHtml += '                 </div>'
            buttonsHtml += '             </div>'
            buttonsHtml += '            <div class="aui-media-list-item-inner aui-list-item-center">'
            buttonsHtml += '                 <div class="aui-list-item-media aui-padded-0" style="width:100%">'
            buttonsHtml += '                     <img src="'+self.openBannerImg+'" id="doorOpenBtnUI">'
            buttonsHtml += '                 </div>'
            buttonsHtml += '             </div>'
            buttonsHtml += '         </div>'
            buttonsHtml += '     </div>'
            buttonsHtml += ' </section>'

            self.doorOpenUIDiv.innerHTML = buttonsHtml;
            console.log('doorOpenUIDiv: ' + buttonsHtml);
            var actionsheetHeight = self.doorOpenUIDiv.offsetHeight;
            self.maskDiv.classList.add("aui-mask-in");
            self.doorOpenUIDiv.style.webkitTransform = self.doorOpenUIDiv.style.transform = "translate3d(0,0,0)";
            self.doorOpenUIDiv.style.opacity = 1;
            self.doorOpenUIDiv.addEventListener("touchmove", function(event){
                event.preventDefault();
            })
            self.maskDiv.addEventListener("touchmove", function(event){
                event.preventDefault();
            })
            if(typeof(api) != 'undefined' && typeof(api) == 'object' && self.frameBounces){
                api.setFrameAttr({
                    bounces:false
                });
            }

            isShow = true;
            var c = this.openTimeout;
            setTimeout(function repeatMe() {

                if(isShow && c>=0){
                    var elDoorOpenWaitTime = $api.byId("doorOpenWaitTimeUI");
                    if(elDoorOpenWaitTime){
                        $api.text(elDoorOpenWaitTime,self.openTitle+c+"s");
                    }
                    c--;
                    
                    setTimeout(repeatMe, 1000); 
                } else {

                    if($api.byId('doorOpenBtnUI')){
                        $api.byId('doorOpenBtnUI').src=self.openBtnEndImg;
                    }

                    // 计时超时后处理
                    if(c<0){
                        if($api.byId('doorOpenWaitTimeUI')){
                            $api.text($api.byId('doorOpenWaitTimeUI'),'连接设备超时！请靠近您所要开的门再点开门');
                        }
                        setTimeout(function(){
                            self.close();
                        },3000);
                    }
                }
            },1000);

        },
        setOpenTitle: function(openTitle){
            if($api.byId('doorOpenWaitTimeUI')){
                $api.text($api.byId('doorOpenWaitTimeUI'),openTitle);
                isShow=false;
            }
        },
        close: function(){
            var self = this;
            isShow = false;
            if(typeof(api) != 'undefined' && typeof(api) == 'object' && self.frameBounces){
                api.setFrameAttr({
                    bounces:true
                });
            }
            if(self.doorOpenUIDiv){
                var actionsheetHeight = self.doorOpenUIDiv.offsetHeight;
                self.doorOpenUIDiv.style.webkitTransform = self.doorOpenUIDiv.style.transform = "translate3d(0,"+actionsheetHeight+"px,0)";
                self.maskDiv.style.opacity = 0;
                setTimeout(function(){
                    if(self.maskDiv){
                        self.maskDiv.parentNode.removeChild(self.maskDiv);
                    }
                    self.doorOpenUIDiv.parentNode.removeChild(self.doorOpenUIDiv);
                    self.maskDiv = self.doorOpenUIDiv = false;
                }, 300)
            }
        }
    };
	window.doorOpenUI = doorOpenUI;
})(window);