var _canRefresh=true;
var _refreshNum=0;

apiready = function(){

    init();

    //pull to refresh
    api.setRefreshHeaderInfo({
        visible: true,
        // loadingImgae: 'wgt://image/refresh-white.png',
        bgColor: '#f2f2f2',
        textColor: '#4d4d4d',
        textDown: '下拉刷新...',
        textUp: '松开刷新...',
        showTime: true
    }, function (ret, err) {

        refreshSbxx();

        //api.parseTapmode();
        api.refreshHeaderLoadDone();
    });


    api.parseTapmode();
};


function closewin(){
    api.closeWin();
}

function openDevList(){
    console.log('openDevList');

    api.openWin({
        name: 'doorDev',
        url: 'doorDev.html',
        pageParam:{ sbxxlist: _sbxxList}
    });
}


/**
 * [refreshSbxx 实时刷新设备信息]
 * @return {[type]} [description]
 */
function refreshSbxx(){
    ble_stop();

    setTimeout(function () {

        if(_canRefresh){
            console.log(api.frameName + '> refreshSbxx 开始实时刷新设备信息！');     

            // 直接刷新
            removeData(_L_sbxxList_timeout);

            _refreshNum++;

            // 判断是非连续刷新超过3次
            if(_refreshNum>=1){
                //api.toast({msg: '系统繁忙，请稍后再试！'});
                console.log(api.frameName + '> refreshSbxx 连续实时刷新超过3次！！！');      

                // 连续刷新超过规定次数后，停用实时刷新，10分钟后重新开启
                _canRefresh = false;

                setTimeout(function () {
                    _canRefresh = true;
                    _refreshNum = 0;
                }, 60000);
            }
        }

        init();
    }, 100);
}



function init(){

	var dqsssq = getData(_L_sssq);
    if(dqsssq){
    	console.log(api.frameName + '> init sssq: ' + dqsssq);  	
                
        // 从服务端取当前用户可用的设备列表
        initSbxx(dqsssq,initBle);

    } else {
    	noBindHouse();

	    setTimeout(function () {
            api.execScript({
                name: 'root',
                script: 'backTab();'
            });
	    }, 500);
    }
}



function initBle(){

    if(_sbxxList && _sbxxList.length>0){
        $api.text($api.byId('doorDevNum'),_sbxxList.length + '个设备');
    } else {
        $api.text($api.byId('doorDevNum'),'无可用设备');
    }

    ble_start();
}



function onlyinit(){

    var dqsssq = getData(_L_sssq);
    if(dqsssq){
        console.log(api.frameName + '> init sssq: ' + dqsssq);      
                
        // 从服务端取当前用户可用的设备列表
        initSbxx(dqsssq);

    }
}


/**
 * 开门操作
 * @return {[type]} [description]
 */
function openDoor(){
    ble_openDoorByRssi(openDoorWait,openDoorSuccess,OpenDoorFailed);
}

/**
 * 开指定的设备
 * @param  {[type]} sbsn [description]
 * @return {[type]}      [description]
 */
function openDoorBySbsn(sbsn){
    ble_openDoorBySbsn(sbsn,openDoorWait,openDoorSuccess,OpenDoorFailed);
}
// function openDoorBySbsn(sbsn){
//     ble_openDoorBySbsn(sbsn,openDoorWait_m2,openDoorSuccess_m2,OpenDoorFailed_m2);
// }



function openDoorWait(){
    console.log(api.frameName + '> openDoorWait');
    
	$api.byId('doorOpenBtn').src='../image/door_openbtn_opening.gif';
	
    var c = 60;
    var elDoorOpenWaitTime = $api.byId("doorOpenWaitTime");
    $api.text(elDoorOpenWaitTime,'正在为您开门请稍候'+c+"s");
    setTimeout(function repeatMe() {
        if(_opening && c>0){
            c--;
            $api.text(elDoorOpenWaitTime,'正在为您开门请稍候'+c+"s");
            setTimeout(repeatMe, 1000); 
        } else {
            //清除中间信息
            //$api.text(elDoorOpenWaitTime,'');
            // 计时超时后处理
            if(c<=0){
                if($api.byId('doorOpenWaitTime')){
                    $api.text($api.byId('doorOpenWaitTime'),'连接设备超时！请靠近您所要开的门再点开门');   
                }
            }

            _opening = false;
            $api.byId('doorOpenBtn').src='../image/door_openbtn.png';
            setTimeout(function(){
                $api.text($api.byId("doorOpenWaitTime"),'');
            }, 3000); 
        }
    },1000);
}


function openDoorCancel(){
    console.log(api.frameName + '> openDoorCancel');

    if(_opening){
        _opening = false;
        $api.byId('doorOpenBtn').src='../image/door_openbtn.png';
        $api.text($api.byId("doorOpenWaitTime"),'');
    }
}


function openDoorSuccess(sbsn,sbdl){
    console.log(api.frameName + '> openDoorSuccess  sbsn: ' + sbsn);

	api.hideProgress();

    //ble_scan();

    api.startPlay({
        path: 'widget://res/wav/open_door_sound.wav'
    }, function(ret, err) {
        if (ret) {
            console.log(api.frameName+ '> opendoor startPlay :' + JSON.stringify(ret));
            //alert('播放完成');
        } else {
            //alert(JSON.stringify(err));
            console.log(api.frameName+ '> opendoor startPlay err:' + JSON.stringify(err));
        }
    });

    $api.text($api.byId("doorOpenWaitTime"),'开门成功');

    setTimeout(function(){
         $api.text($api.byId("doorOpenWaitTime"),'');
    },3000); 

    //api.toast({msg: '开门成功！'})

    $api.byId('doorLogo').src='../image/door_openlogo.png'

    $api.byId('doorOpenBtn').src='../image/door_openbtn.png';

    setTimeout(function () {
        $api.byId('doorLogo').src='../image/door_intologo.png';
        //$api.byId('doorOpenBtn').src='../image/door_openbtn.png';
        
    }, 3000);


    if(sbsn){
        var jlyy = '2';

        // 上传开门日志
        uploadOpenRecord(sbsn,jlyy,sbdl);
    }
}

function OpenDoorFailed(sbsn,cause){
    console.log(api.frameName + '> OpenDoorFailed  sbsn: ' + sbsn + ', cause: ' + cause);

    api.hideProgress();

    //ble_scan();

    $api.text($api.byId("doorOpenWaitTime"),cause); 
    setTimeout(function(){
         $api.text($api.byId("doorOpenWaitTime"),'');
    },5000);    

    //$api.toast("开门失败！ " + cause,5000);

    $api.byId('doorOpenBtn').src='../image/door_openbtn.png';
    
    if(sbsn){
        var jlyy = '16';

        // 上传开门日志
        uploadOpenRecord(sbsn,jlyy,'0');
    }
}



/**
 * 开门方式测试
 * @return {[type]} [description]
 */
var _doorOpenUI;
function openDoorWait_m2(){
    console.log(api.frameName + '> openDoorWait');

    if(!_doorOpenUI){
        _doorOpenUI = new doorOpenUI();
    }
    
    setTimeout(function(){
        _doorOpenUI.init({
            frameBounces:true,//当前页面是否弹动，（主要针对安卓端）
            openBtnOpeningImg: '../image/door_openbtn_opening.gif',
            openBtnEndImg: '../image/door_openbtn.png',
            openBannerImg: '../image/myBackground.jpg',
            openTitle: '正在为您开门请稍候...',
            openTimeout:30
        },function(ret){
            if(ret){
                console.log(api.frameName + '> dooropenUI ret: ' + JSON.stringify(ret));
            }
        });

    },100);
}

function openDoorSuccess_m2(sbsn){
    console.log(api.frameName + '> openDoorSuccess  sbsn: ' + sbsn);

    api.hideProgress();

    api.startPlay({
        path: 'widget://res/wav/open_door_sound.wav'
    }, function(ret, err) {
        if (ret) {
            console.log(api.frameName+ '> opendoor startPlay :' + JSON.stringify(ret));
            //alert('播放完成');
        } else {
            alert(JSON.stringify(err));
        }
    });


    setTimeout(function(){
        if(_doorOpenUI){
            _doorOpenUI.close();
        }
    },3000);

    if(_doorOpenUI){
        _doorOpenUI.setOpenTitle('开门成功！');
    }

    //api.toast({msg: '开门成功！'})

    $api.byId('doorLogo').src='../image/door_openlogo.png'
    setTimeout(function () {
        $api.byId('doorLogo').src='../image/door_intologo.png';
    }, 3000);

    if(sbsn){
        var jlyy = '2';

        // 上传开门日志
        uploadOpenRecord(sbsn,jlyy,'0');
    }
}

function OpenDoorFailed_m2(sbsn,cause){
    console.log(api.frameName + '> OpenDoorFailed  sbsn: ' + sbsn + ', cause: ' + cause);

    api.hideProgress();
    
    if(_doorOpenUI){
        _doorOpenUI.setOpenTitle(cause);
    }

    setTimeout(function(){
        if(_doorOpenUI){
            _doorOpenUI.close();
        }
    },5000);   

    //$api.toast("开门失败！ " + cause,5000);

    if(sbsn){
        var jlyy = '16';

        // 上传开门日志
        uploadOpenRecord(sbsn,jlyy,'0');
    }
}
