var FNImageClip;


apiready = function(){
    api.parseTapmode();
    
    var header = $api.byId('aui-header');
    $api.fixStatusBar(header);
    
    var txurl = api.pageParam.txurl || '';
    $api.byId('txurl').src = txurl;

    FNImageClip = api.require('FNImageClip');
};



function closewin(){
    api.closeWin();
}



function fromAlbum(){
    takePicture('album');
}

function fromCamera(){
    takePicture('camera');
}


function takePicture(sourceType) {

    api.getPicture({
        sourceType: sourceType,
        mediaValue: 'pic',
        allowEdit: true,
        targetWidth: 1024,
        targetHeight: 1024,
        encodingType: 'jpg',
        quality: 50,
        saveToPhotoAlbum: false
    }, function(ret, err) {
        //alert(JSON.stringify(ret));
        console.log(JSON.stringify(ret));
        if(ret && ret.data){
            if(api.systemType=='ios'){
                uploadImg(ret.data);
            } else {
                // android 需要做图片裁剪
                clipImg(ret.data);
            }
        }

    });
}

function clipImg(imgUrl){

    $api.removeCls($api.byId('footer'), 'aui-hide');

    var cw = api.winWidth;
    var ch = api.winWidth;
    var cx = 0;
    var cy = (api.winHeight - $api.byId('footer').offsetHeight - ch)/2;

    FNImageClip.open({
        rect: {
            x: 0,
            y: 0,
            w: api.winWidth,
            h: api.winHeight - $api.byId('footer').offsetHeight
        },
        srcPath: 'file://'+imgUrl,
        style: {
            mask: '#888',
            clip: {
                w: cw,
                h: ch,
                x: cx,
                y: cy,
                borderColor: '#0f0',
                borderWidth: 1,
                appearance: 'rectangle'
            }
        },
        mode: 'image',
        fixedOn: api.frameName
    }, function(ret, err) {
        if (ret) {
            //alert(JSON.stringify(ret));
            console.log(JSON.stringify(ret));

        } else {
            alert(JSON.stringify(err));
        }
    });
}


function cancelClip(){
    FNImageClip.close();
    $api.addCls($api.byId('footer'), 'aui-hide');
}


function saveClip(){

    $api.addCls($api.byId('footer'), 'aui-hide');

    FNImageClip.save({
        destPath: 'fs://imageClip/'+generateUUID()+'.jpg',
        copyToAlbum: false,
        quality: 0.5
    }, function(ret, err) {
        if (ret) {
            console.log(JSON.stringify(ret));

            if(ret.destPath){

                uploadImg(ret.destPath);
                    
                setTimeout(function(){
                    FNImageClip.close();
                },200);
    
            } else {
                alert('图片那里去了？？？');
            }
            
        } else {
            alert(JSON.stringify(err));
        }
    });
}


function generateUUID(){
    var d = new Date().getTime();
    var uuid = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function(c) {
        var r = (d + Math.random()*16)%16 | 0;
        d = Math.floor(d/16);
        return (c=='x' ? r : (r&0x7|0x8)).toString(16);
    });
    return uuid;
};

function uploadImg(imgUrl){

    console.log("uploadImg: " + imgUrl);

    api.showProgress({
        title: '图片上传中...',
        modal: true
    });

    var model = api.require('model');
    model.uploadFile({
        report: false,
        data: {
            file: {
                url: imgUrl
            }
        }
    }, function(ret, err){
        if( ret ){
            
            console.log( 'uploadFile: ' + JSON.stringify( ret ) ); 
            ensure(ret.url);

        }else{
            api.toast({msg: '网络不给力'})

            alert( JSON.stringify( err ) );
        }

        api.hideProgress();
    });

}


function ensure(txUrl) {

    var bodyParam = {
        action: "person_edit",
        req: {
            txurl: txUrl
        }
    }

    api.showProgress({
        title: '修改中...',
        modal: false
    });

    // Post
    ajaxPost(bodyParam, function (ret, err) {

        // api.alert({
        //     msg: ret
        // });

        if (ret && ret.state) {

            //update personal center
             api.execScript({
                name: 'root',
                frameName: 'my',
                script: 'getUserInfo();'
            });

            // setTimeout(function () {
            //     // api.execScript({
            //     //     name: 'userInfo',
            //     //     frameName: 'userInfo_frm',
            //     //     script: 'updateTxUrl("'+txUrl+'");'
            //     // });
            //     api.execScript({
            //         name: 'myUserInfo',
            //         frameName: 'myUserInfo_frm',
            //         script: 'init();'
            //     });
            // }, 500);
 
            //缓存头像图片文件
            api.imageCache({
                url: txUrl
            }, function(ret, err) {
                console.log('imageCache: ' + JSON.stringify( ret ) )
                if(ret){
                    if(ret.url){
                        $api.byId('txurl').src = ret.url;
                        $api.setStorage('usertxurl',ret.url);

                        // 更新用户信息页面的头像
                        var cmdContent = 'updateTxUrl(\''+ret.url+'\');';
                        api.execScript({
                            name: 'myUserInfo',
                            frameName: 'myUserInfo_frm',
                            script: cmdContent
                        });

                    }
                }
            });
                        
        } else {
            api.toast({msg: ret.cljg})
            if(err){
                api.alert({
                    msg: err.msg
                });
            }
        }

        api.hideProgress();
    })

}
