var _userInfo;

apiready = function () {
	init();

    api.parseTapmode();
};


function init(){

    var _userInfo = $api.getStorage('userinfo');
    if(_userInfo){

        if(_userInfo.txurl){
            // 缓存头像图片文件
            api.imageCache({
                url: _userInfo.txurl
            }, function(ret, err) {
                if(ret){
                    if(ret.url){
                        _userInfo.cachedTxUrl = ret.url;
                        $api.setStorage('userinfo', _userInfo);
                    }
                } else {
                    _userInfo.cachedTxUrl = _userInfo.txurl;
                }

                // 渲染显示用户信息
                showUserInfo(_userInfo);
            });

        } else {
            _userInfo.cachedTxUrl = "../image/userTitle.png";
            $api.setStorage('userinfo', _userInfo);
            showUserInfo(_userInfo);
        }
        
    } else {
        // 从服务端更新最新用户信息
        getUserInfo();
    }
}


function openSetting(){
    api.openWin({
        name: 'setting',
        url: 'setting.html',
        opaque: true,
        vScrollBarEnabled:false
    });
}


function openUserInfo(){
    api.openWin({
        name: 'myUserInfo',
        url: 'myUserInfo.html',
        opaque: true,
        vScrollBarEnabled:false,
        pageParam: {
            userinfo: _userInfo
        }
    });
}


function openHouseInfo(){
    api.openWin({
        name: 'myHouse',
        url: 'myHouse.html',
        opaque: true,
        vScrollBarEnabled:false,
        pageParam: {
            userinfo: _userInfo
        }
    });
}


function openMyMessage(){
    api.openWin({
        name: 'myMessage',
        url: 'myMessage.html',
        opaque: true,
        vScrollBarEnabled:false,
        pageParam: {
            userinfo: _userInfo
        }
    });
}


function openMyFavorite(){
    api.openWin({
        name: 'myFavorite',
        url: 'myFavorite.html',
        opaque: true,
        vScrollBarEnabled:false,
        pageParam: {
            userinfo: _userInfo
        }
    });
}


function openMyVisitor(){
    api.openWin({
        name: 'myVisitor',
        url: 'myVisitor.html',
        opaque: true,
        vScrollBarEnabled:false,
        pageParam: {
            userinfo: _userInfo
        }
    });
}



function closewin(){
    api.closeWin();
}


function getUserInfo(){

    var bodyParam = {
        action: "person_info"
    }

    api.showProgress({
        title: '更新用户信息...',
        modal: false
    });

    // Post
    ajaxPost(bodyParam, function (ret, err) {

        // api.alert({
        //     msg: ret
        // });

        if (ret && ret.state) {

        	if(ret.data){
        		// 将用户信息保存在本地
        		var userinfo = ret.data;

        		if(userinfo.txurl){
        			// 缓存头像图片文件
	        		api.imageCache({
					    url: userinfo.txurl
					}, function(ret, err) {

						if(ret){

					        if(ret.url){

						        userinfo.cachedTxUrl = ret.url;
      
                                //保存本地对象
                                _userInfo = userinfo
                                $api.setStorage('userinfo', _userInfo);

						        // 渲染显示用户信息
						        showUserInfo(userinfo);
					        }

						}
	
					});

        		} else {

        			userinfo.cachedTxUrl = "../image/userTitle.png";

                    //保存本地对象
                    _userInfo = userinfo
                    $api.setStorage('userinfo', _userInfo);

                    // 渲染显示用户信息
	                showUserInfo(userinfo);
        		}

        	}
            
        } else {
            if(ret && ret.cljg){
                api.toast({msg: ret.cljg})
            }
 
            if(err){
                api.alert({
                    msg: err.msg
                });
            }
        }

        api.hideProgress();
    })

}

function showUserInfo(ret){
    // api.alert({
    //     msg: ret.cachedTxUrl
    // });

	// 整个用户对象保存到本地 
    if(ret){
        $api.setStorage('userinfo',ret);
        $api.setStorage('usertxurl',ret.cachedTxUrl);
        $api.setStorage('curruid',ret.sjh);

        // 渲染页面
        var content = $api.byId('content');
        var tpl = $api.byId('template').text;
        var tempFn = doT.template(tpl);
        content.innerHTML = tempFn(ret);

        //alert(content.innerHTML);
        //
        // var sssqmc = getData('sssqmc');
        // $api.text($api.byId('sssqmc'),sssqmc);
    }
}
