var _noticeFbsj;
var _noticeList;

apiready = function () {
    // 从缓存上次更新的数据
    _noticeFbsj = $api.getStorage('noticeFbsj'); 
    _noticeList = $api.getStorage('noticeList'); 

    if(_noticeList){
        showNotice(_noticeList);
    }
    
    //console.log(api.frameName + '> 取最新的 _noticeList:' + JSON.stringify(_noticeList));
    
    init()
    
    //pull to refresh
    api.setRefreshHeaderInfo({
        visible: true,
        // loadingImgae: 'wgt://image/refresh-white.png',
        bgColor: '#f2f2f2',
        textColor: '#4d4d4d',
        textDown: '下拉刷新...',
        textUp: '松开刷新...',
        showTime: true
    }, function (ret, err) {
        init()
        api.refreshHeaderLoadDone();
    });

    api.parseTapmode();
};


// 初始化，下载公告列表
function init() {

    // 从页面参数取当前的用户社区
    var dqsssq = api.pageParam.sssq;
    if(!dqsssq){
        dqsssq = getData('sssq');
    }

    console.log(api.frameName + '> init() sssq:' + dqsssq);

    var bodyParam = {
        action: "notice_info",
        req: {
            sssq: dqsssq,
            gxsj: _noticeFbsj
        }
    }

    ajaxPost(bodyParam, function (ret, err) {
        console.log('getData: ' + JSON.stringify(ret) );
        if (ret && ret.state) {
            if( ret.data && ret.data.length > 0 ) {
                var noticelist = ret.data;

                for(var idx in noticelist){
                    noticelist[idx].fbsjxs = formatTime12(noticelist[idx].gxsj);
                    //遍历json数组,设置不同类型公告的类型图片
                    if(noticelist[idx].lx == '1'){
                        noticelist[idx].typeimg = '../image/notice_lx_1.png';
                    }
                    if(noticelist[idx].lx == '2'){
                        noticelist[idx].typeimg = '../image/notice_lx_2.png';
                    }
                }

                mergeNotice(noticelist);
				showNotice(_noticeList);
                api.hideProgress();
                return;
            }
            
        } else {
            if(ret && !ret.state){
                api.toast({msg: ret.cljg})
                // api.alert({
                //     msg: ret.cljg
                // });
            }
            if(err){
                api.alert({
                    msg: err.msg
                });
            }
        }

        api.hideProgress();
    })
}

function merge(dataList){
	for(var i = dataList.length-1; i>=0; i--){
		for (var j in _noticeList){
			if(dataList[i].ggid == _noticeList[j].ggid){
	            if(dataList[i].fbbz==0){
	            	if(_noticeList.length>1){
		        		_noticeList.splice(j,1);
		        	}else{
		        		_noticeList = $api.strToJson("[]");
		        	}
	        		//console.log(api.frameName + '> merge(老数据已取消发布，则剔除)  dataInfo:' + dataList[i].bt);
	        	}
	        	if(dataList[i].fbbz==1){
	        		if(_noticeList.length>1){
		        		_noticeList.splice(j,1);
		        	}else{
		        		_noticeList = $api.strToJson("[]");
		        	}
		        	var dataInfo = markFav(dataList[i]);//更新收藏标志
		        	//console.log(api.frameName + '> merge(老数据未取消发布，更新收藏标志)  dataInfo:' + dataInfo.bt+" faved:"+dataInfo.faved);
		        	_noticeList.unshift(dataInfo);
	        		//console.log(api.frameName + '> merge(老数据未取消发布，则更新老数据)  _noticeList:' + JSON.stringify(_noticeList));
	        	}
	        	dataList[i].main_resolved = 1;//设置对象状态是已处理
	        	//console.log(api.frameName + '> merge(设置已处理标志为1)  main_resolved:' + dataList[i].main_resolved);
	        	break;
	        }
		}
		//console.log(api.frameName + '> merge(开始处理新数据)  main_resolved:' + dataList[i].main_resolved + "标题："+dataList[i].bt);
		if(!dataList[i].main_resolved){//新数据
			//console.log(api.frameName + '> merge(处理新数据)  main_resolved:' + dataList[i].main_resolved + "标题："+dataList[i].bt);
			if(dataList[i].fbbz==1){
				var dataInfo = markFav(dataList[i]);//更新收藏标志
		        //console.log(api.frameName + '> merge(处理新数据，更新收藏标志)  dataInfo:' + dataInfo.bt+" faved:"+dataInfo.faved);
				_noticeList.unshift(dataInfo);
			}
		}
		delete dataList[i].main_resolved;
	}
}

function markFav(dataInfo){
	var favList = $api.getStorage("favList");
	if(favList&&favList.length>0){
		for(var i in favList){
			if(favList[i].destid==dataInfo.ggid){
	            dataInfo.faved='1';
	            dataInfo.scid=favList[i].scid;
	        }
		}
	}
	return dataInfo;
}

// 合并记录
function mergeNotice(noticeList){
    console.log(api.frameName + '> mergeNotice()  noticeList:' + JSON.stringify(noticeList));
    if(noticeList && noticeList.length>0){
    	_noticeList = $api.getStorage('noticeList');//更新前取最新的记录
        if(_noticeList){
        	merge(noticeList);
        } else {
        	_noticeList = $api.strToJson("[]");
        	for(var i in noticeList){
        		if(noticeList[i].fbbz==1){
	        		_noticeList.push(noticeList[i]);
	        	}
        	}
        }

        _noticeFbsj = _noticeList[0].gxsj;

        $api.setStorage('noticeList', _noticeList);
        $api.setStorage('noticeFbsj', _noticeFbsj);

        console.log(api.frameName + '> mergeNotice()  _noticeList:' + JSON.stringify(_noticeList));
    }    
}

function cancelFavNoticeIcon(ggid){
	//console.log("返回的ggid:"+ggid);
	var noticedotEl =  $api.byId('favNoticeIcon' + ggid);
    if(noticedotEl){
        $api.remove(noticedotEl);
    }
}

function setupFavNoticeIcon(ggid){
	//console.log("返回的ggid:"+ggid);
	var noticedotEl =  $api.byId('favNoticeIcon' + ggid);
    if(noticedotEl){
    	
    }else{
    	var el = $api.byId('notice' + ggid);
    	$api.append(el,'<span class="aui-iconfont aui-icon-like aui-text-info" id="favNoticeIcon'+ggid+'"></span>');
    }
}


function openNoticeByLx(lx) {
    console.log(api.frameName + '> openNoticeByLx() lx:' + lx);

    var noticelist = _noticeList;
    var jsonarray = $api.strToJson("[]");
    
    for(var idx in noticelist){
        //遍历json数组,选择匹配的类型
        if(noticelist[idx].lx == lx){
            jsonarray.push(noticelist[idx]);
        }
    }

    showNotice(jsonarray);
}

function openNoticeUnRead() {
    console.log(api.frameName + '> openNoticeUnRead()');
    var noticelist = _noticeList;
    var jsonarray = $api.strToJson("[]");
    
    for(var idx in noticelist){
        //遍历json数组,选择匹配的类型
        if(!noticelist[idx].readed){
            jsonarray.push(noticelist[idx]);
        }
    }

    showNotice(jsonarray);
}

function openNoticeReaded() {
    console.log(api.frameName + '> openNoticeReaded()');
    var noticelist = _noticeList;
    var jsonarray = $api.strToJson("[]");
    
    for(var idx in noticelist){
        //遍历json数组,选择匹配的类型
        if(noticelist[idx].readed && noticelist[idx].readed=='1'){
            jsonarray.push(noticelist[idx]);
        }
    }

    showNotice(jsonarray);
}


function showNotice(noticelist){

    if(noticelist && noticelist.length > 0){

        //渲染页面
        var content = $api.byId('content');
        var tpl = $api.byId('template').text;
        var tempFn = doT.template(tpl);
//      for(var i in noticelist){
//      	alert(noticelist[i].bt+noticelist[i].favorite);
//      }
        content.innerHTML = tempFn(noticelist);
        // alert(content.innerHTML); 

        // 统计当前公告数量
        showNoticeHead();

        api.parseTapmode();
    }
}

// 统计当前公告数量
function showNoticeHead(){
    if(_noticeList){
        var numLx1 = 0;
        var numLx2 = 0;
        var numUnRead = 0;
        var numReaded = 0;

        for(var idx in _noticeList){
            //遍历json数组,设置不同类型公告的类型图片
            if(_noticeList[idx].lx == '1'){
                numLx1++;
            }
            if(_noticeList[idx].lx == '2'){
                numLx2++;
            }
            if(_noticeList[idx].readed && _noticeList[idx].readed == '1'){
                numReaded++;
            } else {
                numUnRead++;
            }
        }
        
        $api.byId("notice").innerHTML=numLx1;
        $api.byId("news").innerHTML=numLx2;
        $api.byId("noticeUnRead").innerHTML=numUnRead;
        $api.byId("noticeReaded").innerHTML=numReaded;
    } 
    
    api.parseTapmode();   
}


function openNoticeDetail(noticeId){
    if(noticeId){
        console.log('notice_frm openNoticeDetail: noticeId=' + noticeId);


        // 记录也读状态
        for(var idx in _noticeList){
            //遍历json数组,选择匹配的类型
            if(_noticeList[idx].ggid == noticeId){
                _noticeList[idx].readed='1';
                $api.setStorage('noticeList', _noticeList);
            }
        }

        var noticedotEl =  $api.byId('readedIcon' + noticeId);
        if(noticedotEl){
            $api.remove(noticedotEl);
        }

        showNoticeHead();

        api.openWin({
            name: 'noticeDetail',
            url: 'noticeDetail.html',
            opaque: true,
            vScrollBarEnabled: false,
            pageParam:{noticeid: noticeId}
        });

    }
}




