function modifyNick(nickname) {
    nickname = nickname || '';
    api.openWin({
        name: 'modifyNick',
        url: 'modifyNick.html',
        opaque: true,
        pageParam: {
            nickname: nickname
        },
        vScrollBarEnabled: false
    });
}

function modifyPwd() {
    api.openWin({
        name: 'modifyPwd',
        url: 'modifyPwd.html',
        opaque: true,
        vScrollBarEnabled: false
    });
}

function loginBtn() {
    api.openWin({
        name: 'userLogin',
        url: 'userLogin.html',
        opaque: true,
        vScrollBarEnabled: false
    });
}

function loginOut() {

    api.showProgress({
        title: '正在注销...',
        modal: false
    });


    var bodyParam = {
        action: "exit"
    }

    // Post
    ajaxPost(bodyParam, function (ret, err) {

        // api.alert({
        //     msg: ret
        // });

        if (ret && ret.state) {

            var uid=$api.getStorage('uid');
            console.log('unbindPush: uid=' + uid);

            var push = api.require('push');
            push.unbind({
                userName: uid,
                userId: uid
            }, function(ret, err){
                if( ret ){
                    //alert('bind: ' + JSON.stringify( ret) );
                    console.log(api.frameName + ', unbind: ' + JSON.stringify( ret) );
                }else{
                    alert( JSON.stringify( err) );
                }
            });

            $api.rmStorage('token');
            
            api.execScript({
                name: 'root',
                script: 'openlogin();'
            });

            setTimeout(function () {
                api.closeWin();
            }, 600);

        } else {

            if(ret && !ret.state){
                api.alert({
                    msg: ret.cljg
                });
            }

            if(err){
                api.alert({
                    msg: err.msg
                });
            }

        }
        api.hideProgress();
    })

}

function toRegister() {
    api.openWin({
        name: 'userLogin',
        url: 'userLogin.html',
        opaque: true,
        vScrollBarEnabled: false
    });
}

//清除下载缓存文件、拍照临时文件、网页缓存文件等
function clearData() {
    api.clearCache();

    setTimeout(function () {
        api.alert({
            msg: '缓存已清空!'
        });

        checkCacheSize();
    }, 300);
}

function openAbout() {
    api.openWin({
        name: 'about',
        url: './about.html'
    });
}


function checkUpdate() {
    var mam = api.require('mam');
    mam.checkUpdate(function(ret, err) {
        if (ret && ret.result) {
            var result = ret.result;
            if (result.update == true && result.closed == false) {
                var str = '新版本型号:' + result.version + ';更新提示语:' + result.updateTip + ';下载地址:' + result.source + ';发布时间:' + result.time;
                api.confirm({
                    title : '有新的版本,是否下载并安装 ',
                    msg : str,
                    buttons : ['确定', '取消']
                }, function(ret, err) {
                    if (ret.buttonIndex == 1) {
                        if (api.systemType == "android") {
                            api.download({
                                url : result.source,
                                report : true
                            }, function(ret, err) {
                                if (ret && 0 == ret.state) {/* 下载进度 */
                                    api.toast({
                                        msg : "正在下载应用" + ret.percent + "%",
                                        duration : 2000
                                    });
                                }
                                if (ret && 1 == ret.state) {/* 下载完成 */
                                    var savePath = ret.savePath;
                                    api.installApp({
                                        appUri : savePath
                                    });
                                }
                            });
                        }
                        if (api.systemType == "ios") {
                            api.installApp({
                                appUri : result.source
                            });
                        }
                    }
                });
            } else {
                api.alert({
                    msg : "暂无更新"
                });
            }
        } else {
            api.alert({
                msg : err.msg
            });
        }
    });
}


function checkCacheSize(){
    //同步返回结果：
    var size = api.getCacheSize({
        sync: true
    });

    if(parseInt(size)<1024){
        size = '';
    } else if (parseInt(size) >= 1024 && parseInt(size)<(1024*1024)) {
        size = Math.round(parseInt(size)/1024) + 'KB';

    } else if (parseInt(size)>=(1024*1024)) {
        size = Math.round(parseInt(size)/(1024*1024)) + 'MB';
    }

    //alert(size);

    $api.text($api.byId('cachesize'),size);
}


apiready = function () {
    api.parseTapmode();


    checkCacheSize();
};