

// 验证手机
function ensure() {
    api.showProgress({
        title: '验证手机...',
        modal: false
    });

    var phonenum = $api.byId('phonenum').value;
    var verCode=$api.byId('vercode').value;

    var bodyParam = {
        action: "check_code",
        req: {
            "phone": phonenum, 
            "code": verCode
        }
    }

    // Post
    ajaxPost(bodyParam, function (ret, err) {

        // api.alert({
        //     msg: ret
        // });
        if (ret && ret.state) {

            // 保存验证过的手机号码和验证码
            $api.setStorage('username', phonenum);
            $api.setStorage('vercode', verCode);
            
            // 手机验证成功
            // 进入设置登录密码页面
            userSetPassword();
            
            // 关闭本页面
            // setTimeout(function () {
            //     api.closeWin();
            // }, 500);

        } else {

            if(ret && !ret.state){
                api.alert({
                    msg: ret.cljg
                });
            }

            if(err){
                api.alert({
                    msg: err.msg
                });
            }

        }

        api.hideProgress();
    })
}


function userSetPassword() {

    api.openFrame({
        name: 'userSetPassword',
        url:  'userSetPassword.html',
        bounces: false,
        reload: false,
        pageParam: api.pageParam,
        rect: {
            x: 0,
            y: 0,
            w: 'auto',
            h: 'auto'
        }
    });

    setTimeout(function () {
        api.closeFrame({
            name: 'userRegister'
        });

        api.closeFrame({
            name: 'userReset'
        });

        api.closeFrame({
            name: 'userCheckPhoneNum_frm'
        });

    }, 100);
}


function getVerCode(){

    if(!checkPhoneNum()){
        return;
    }

    if(isGetVerCodeIng){
        alert('正在请求验证码，请耐心等待！');
        return;
    }

    api.showProgress({
        title: '发送验证码...',
        modal: false
    });

    var phonenum = $api.byId('phonenum').value;
    
    var bodyParam = {
        action: "get_code",
        req: {
            "phone": phonenum
        }
    }

    // Post
    ajaxPost(bodyParam, function (ret, err) {

        // api.alert({
        //     msg: ret
        // });
        if (ret && ret.state) {
            
            //验证码发出后处理
            var elRegSubmit=$api.byId('regSubmit');

            if($api.hasCls(elRegSubmit, 'aui-btn-info')){
                $api.removeCls(elRegSubmit, 'aui-btn-info');
                //elRegSubmit.disabled=true;
            } else {
                $api.addCls(elRegSubmit, 'aui-btn-info');
                //elRegSubmit.disabled=false;
            }
            
            elVerCode.disabled=false;
            elVerCode.focus();

            var elBtnGetVerCode=$api.byId('btnGetVerCode');
            $api.removeCls(elBtnGetVerCode, 'aui-btn-info');

            var orgText = $api.text(elBtnGetVerCode);
            //alert('elBtnGetVerCode text:' + orgText);

            isGetVerCodeIng=true;

            var timerIdx = 60;
            setTimeout(function repeatMe() {
                    timerIdx--;

                    $api.text(elBtnGetVerCode,orgText+timerIdx);

                    if(timerIdx>0){
                        setTimeout(repeatMe, 1000); 
                    } else {
                        $api.text(elBtnGetVerCode,orgText);
                        $api.addCls(elBtnGetVerCode, 'aui-btn-info');

                        isGetVerCodeIng=false;
                    }
            },1000);


        } else {

            if(ret && !ret.state){
                api.alert({
                    msg: ret.cljg
                });
            }

            if(err){
                api.alert({
                    msg: err.msg
                });
            }

        }

        api.hideProgress();
    })


}


function checkPhoneNum(){

    var phonenum = $api.byId('phonenum').value;

    // //alert(phonenum.length);
    if(phonenum && phonenum.length==11){
        var myreg = /^13[0-9]{9}$|14[0-9]{9}|15[0-9]{9}$|16[0-9]{9}$|18[0-9]{9}$|17[0-9]{9}$|19[0-9]{9}$/; 
        return myreg.test(phonenum);
    } else {
        return false;
    }

}

var elPhoneNum=$api.byId('phonenum');
$api.addEvt(elPhoneNum, 'keyup', function(){
    var elBtnGetVerCode=$api.byId('btnGetVerCode');
    if(checkPhoneNum()){
        $api.addCls(elBtnGetVerCode, 'aui-btn-info');
    } else {
        $api.removeCls(elBtnGetVerCode, 'aui-btn-info');
    }

    if($api.val(elPhoneNum).length>11){
        alert('请输入正确的手机号码！');
    }

});


var elVerCode=$api.byId('vercode');
elVerCode.disabled=true;
$api.addEvt(elVerCode, 'keyup', function(){
    var elBtnRegSubmit=$api.byId('regSubmit');
    if($api.val(elVerCode).length==6){
        $api.addCls(elBtnRegSubmit, 'aui-btn-info');
    } else {
        $api.removeCls(elBtnRegSubmit, 'aui-btn-info');
    }
});


var isGetVerCodeIng = false;


apiready = function(){
    api.parseTapmode();

    if(api.pageParam){
        if(api.pageParam.checkAction){
            $api.byId('checkAction').value = api.pageParam.checkAction;

            // 上次登录的手机号码
            if(api.pageParam.checkAction=='register'){
                // 设置输入焦点
                $api.byId('phonenum').focus();

            } else {
                var username = $api.getStorage('username');
                if(username){
                    $api.byId('phonenum').value = username;
                    
                    var elBtnGetVerCode=$api.byId('btnGetVerCode');
                    if(checkPhoneNum()){
                        $api.addCls(elBtnGetVerCode, 'aui-btn-info');
                    } else {
                        $api.removeCls(elBtnGetVerCode, 'aui-btn-info');
                    }
                }
            }

        } else {
            alert('调用手机号码验证异常！');
        }

        // if(api.pageParam.txtTitle){
        //     $api.text($api.byId('txtCheckTitle'), api.pageParam.txtTitle);
        // }

        // if(api.pageParam.btnText){
        //     $api.text($api.byId('regSubmit'), api.pageParam.btnText);
        // }
           
    }



}
